Index: lib/matplotlib/legend.py
===================================================================
--- lib/matplotlib/legend.py	(revision 6174)
+++ lib/matplotlib/legend.py	(working copy)
@@ -306,18 +306,26 @@
                 ret.append(legline)
 
             elif isinstance(handle, RegularPolyCollection):
-                if self.numpoints == 1:
-                    xdata = np.array([left])
-                p = Rectangle(xy=(min(xdata), y-3/4*HEIGHT),
-                              width = self.handlelen, height=HEIGHT/2,
-                              )
-                p.set_facecolor(handle._facecolors[0])
-                if handle._edgecolors != 'none' and len(handle._edgecolors):
-                    p.set_edgecolor(handle._edgecolors[0])
-                self._set_artist_props(p)
-                p.set_clip_box(None)
-                p.set_clip_path(None)
-                ret.append(p)
+                xvals=[min(xdata),min(xdata)+self.handlelen/2,min(xdata)+self.handlelen]
+                yvals=[y-3/4*HEIGHT,y-1/4*HEIGHT,y-3/4*HEIGHT]
+                nverts=handle.get_paths()[0].vertices.shape[0]-1
+                szs=[min(handle._sizes),max(handle._sizes)]
+                szs.insert(1,(szs[0]+szs[1])/2)
+                rpc = RegularPolyCollection(nverts,
+                    offsets=zip(xvals,yvals),
+                    transOffset=self.get_transform(),
+                    edgecolors=handle.get_edgecolors(),
+                    linewidth=handle.get_linewidth(),
+                    sizes=szs,
+                    rotation=handle._rotation)
+                if handle.get_array() is None:
+                    rpc.set_facecolors(handle.get_facecolors())
+                else:
+                    rpc.set_array(np.array([0,0.5,1]))
+                    rpc.set_cmap(handle.cmap)
+                    rpc.set_norm(handle.norm)
+                rpc.set_figure(self.figure)
+                ret.append(rpc)
 
             else:
                 ret.append(None)
@@ -532,6 +540,12 @@
             elif isinstance(handle, Rectangle):
                 handle.set_y(y+1/4*h)
                 handle.set_height(h/2)
+            elif isinstance(handle,RegularPolyCollection):
+                offsets = handle.get_offsets()
+                xvals = [x for (x, _) in offsets]
+                yy = y + h
+                yvals=[yy-4./8*h,yy-3./8*h,yy-4./8*h]
+                handle.set_offsets(zip(xvals, yvals))
 
         # Set the data for the legend patch
         bbox = self._get_handle_text_bbox(renderer)
Index: lib/matplotlib/collections.py
===================================================================
--- lib/matplotlib/collections.py	(revision 6174)
+++ lib/matplotlib/collections.py	(working copy)
@@ -147,6 +147,12 @@
             offsets, transOffset.frozen())
         result = result.inverse_transformed(transData)
         return result
+        
+    def get_window_extent(self, renderer):
+        bbox = self.get_datalim(transforms.IdentityTransform())
+        #TODO:check to ensure that this does not fail for
+        #cases other than scatter plot legend
+        return bbox
 
     def _prepare_points(self):
         """Point prep for drawing and hit testing"""
